#include "stdafx.h"
#include "AlexfHistogram.h"
#include "AlexfStaticHistogram.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CAlexfStaticHistogram::CAlexfStaticHistogram()
{
	m_bOK = FALSE;
	m_lTextLines = 0;
	m_lTextWidth = 0;
	m_lStack = 0;
	m_dMaxValue = 1;

	m_lArraySize = GetSystemMetrics(SM_CXSCREEN);{
    loVal   = 0.0;
    hiVal   = 1.0;
    numBins = m_lArraySize;
	maxValsPerBin = 5;
    w = (hiVal - loVal) / numBins;

    myHistogram = new double [numBins];
    for(int i = 0; i < numBins; i++) {
        myHistogram [i] = 0;
    }
}
	myHistogram = new DOUBLE[m_lArraySize];		//This creates the array on the heap.
	
	if (!myHistogram) return;
	ZeroMemory(myHistogram, m_lArraySize * sizeof(DOUBLE));
	m_bOK = TRUE;
}

CAlexfStaticHistogram::~CAlexfStaticHistogram()
{
	if (myHistogram) delete [] myHistogram;
}


BEGIN_MESSAGE_MAP(CAlexfStaticHistogram, CStatic)
	ON_WM_PAINT()
END_MESSAGE_MAP()

void CAlexfStaticHistogram::OnPaint() 
{
	if (!m_bOK)
	{
		CStatic::OnPaint();
		return;
	}
	CPaintDC dc(this); 
	CRect cr;
	GetClientRect(&cr);
	if (m_bNeedFullRedraw)
	{
		m_bNeedFullRedraw = FALSE;
		dc.FillRect(cr, & CBrush(GetSysColor(COLOR_BTNFACE)));
	}
	CRect cr1(cr);
	if (m_bTextLeft) cr1.right = cr1.left + m_lTextWidth;
	else cr1.left = cr1.right - m_lTextWidth;
// text
	dc.SetBkMode(TRANSPARENT);
	dc.SetTextColor(GetSysColor(COLOR_BTNTEXT));
	int hh = 0;
	if (m_lTextLines != 0) hh = cr.Height() / m_lTextLines;
	cr1.right = cr1.left + m_lTextWidth;
	dc.FillRect(cr1, & CBrush(GetSysColor(COLOR_BTNFACE)));
	cr1.bottom = cr1.top + hh;
	CFont* pOldFont = dc.SelectObject(GetFont());
	for (int i = 0; i < m_lTextLines; i++)
	{
		dc.DrawText(text[i], (LPRECT)&cr1,
		DT_WORDBREAK | DT_CENTER | DT_VCENTER);
		cr1.OffsetRect(0, hh);
	}
	dc.SelectObject(pOldFont);
// graph
	if (m_dMaxValue == 0) return;
	if (m_bTextLeft) cr.left += m_lTextWidth;
	else cr.right -= m_lTextWidth;
	cr1 = cr;
	if (m_bMotionLToR) cr1.right = cr1.left + 2;
	else cr1.left = cr1.right - 2;
	i = m_lStack;
	cr1.bottom -= 1;
	int h = cr.Height() - 2;
	while (TRUE)
	{
		int h1 = 0;
		if (m_dMaxValue != 0) h1 = (int)((DOUBLE)( h * myHistogram[i])/maxValsPerBin / m_dMaxValue);
		if (h1 > h) h1 = h;
		cr1.top = cr.top;
		cr1.bottom = cr.bottom - h1;
		dc.FillRect(cr1, & CBrush(GetSysColor(COLOR_BTNFACE)));
		cr1.top = cr.bottom - h1;
		cr1.bottom = cr.bottom;
		dc.FillRect(cr1, & CBrush(GetSysColor(COLOR_BTNHIGHLIGHT)));
		if (m_bMotionLToR) cr1.OffsetRect(3, 0);
		else cr1.OffsetRect(-3, 0);
		if (i == 0) i = m_lArraySize;
		i--;
		if (m_bMotionLToR)
		{
			if (cr1.left > cr.right - 3) break;
		}
		else
		{
			if (cr1.left < cr.left) break;
		}
	}
}

BOOL CAlexfStaticHistogram::Add(DOUBLE val)
{
	/*m_lStack++;
	if (m_lStack >= m_lArraySize) m_lStack = 0;  // This reads the random numbers from 
	myHistogram[m_lStack] = dValue;		*/		 // the array and then calls the function to
	//{
    //if(val < loVal) {
	//cout << "Warning: val " << val << " is too low\n" ;
    //} else if (val > hiVal) {
	//cout << "Warning: val " << val << " is too high\n" ;
    //	} else if (val == hiVal) {
    //   myHistogram [numBins]++;
    //} else {
	for(int i = 0; i < numBins; i++) {
 
	    if((loVal + i * w) <= val && val < (loVal + (i + 1) * w)) {
		// val belongs in i'th bin

		myHistogram [i]++;
	    }
	} 
   // }
//}
	RedrawWindow();								 // draw the graph.
	return TRUE;
}

/*
#include<iostream.h>
#include<fstream.h>

class Histogram
{
public:
    Histogram (float _loVal, float _hiVal, int _numBins);
    ~Histogram() {}

    void add(float val);

    void view();

private:
    int* myHistogram;

    float loVal, hiVal;
    int numBins;

    float w;  // width of bin
};

Histogram::Histogram (float _loVal, float _hiVal, int _numBins) {
    loVal   = _loVal;
    hiVal   = _hiVal;
    numBins = _numBins;

    w = (hiVal - loVal) / numBins;

    myHistogram = new int [numBins];
    for(int i = 0; i < numBins; i++) {
        myHistogram [i] = 0;
    }
}


void Histogram :: add(float val) {
    if(val < loVal) {
	cout << "Warning: val " << val << " is too low\n" ;
    } else if (val > hiVal) {
	cout << "Warning: val " << val << " is too high\n" ;
    } else if (val == hiVal) {
        myHistogram [numBins]++;
    } else {
	for(int i = 0; i < numBins; i++) {
 
	    if((loVal + i * w) <= val && val < (loVal + (i + 1) * w)) {
		// val belongs in i'th bin

		myHistogram [i]++;
	    }
	} 
    }
}

void Histogram ::view() {
    cout << "\n";

    int maxBin = 0;
    for(int i = 0; i < numBins; i++) {
	if(myHistogram [i] > maxBin)
            maxBin = myHistogram [i];
    }

    for(int n = maxBin ; n > 0 ; n--) {
        for(int i = 0; i < numBins; i++)
            if(myHistogram [i] >= n)
	        cout << "    X";
            else
	        cout << "     ";
	cout << "\n";
    }

    cout << "\n";
    for(int i = 0; i < numBins; i++) {
	cout << "    " << i ;
    }
    cout << "\n";
}

int main()
{
	float loVal, hiVal;
        int numBins;
        char filename [100];
	
	cout << "Please enter lowest value: ";
	cin >> loVal;
	cout << "Please enter highest value: ";
	cin >> hiVal;
	cout << "\nPlese select number of bins: ";
	cin >> numBins;

	cout << "\nPlese select file to get data from: ";
	cin >> filename ;
	
        ifstream dataStream(filename);

	Histogram counter(loVal, hiVal, numBins);

        float val ;
        while(dataStream >> val)
          counter.add(val);

        counter.view();
        
	return 0;
}


*/